// I18N

var i18n = {

    // EN
    'en': {
        'popup': {
            'title': 'Agnia Wallet',
            'menu': {
                'claims': 'Claims',
                'permissions': 'Permissions',
                'security': 'Settings',
                'logout': 'Logout'
            },
            'noninitiated':
            {
                'title': 'Set your wallet password',
                'intro': 'We\'re going to create your wallet. It will be ciphered with your password',
                'wallet_name': 'Name',
                'password': 'Password',
                'password2': 'Repeat Password',
                'show_import': 'I already have a wallet',
                'import_file': 'wallet',
                'file_password': 'Wallet password',
                'set': 'Set'
            },
            'askpassword':
            {
                'title': 'Unlock your wallet',
                'password': 'Password',
                'unlock': 'Unlock'
            },
            'initiated':
            {
                'wallet_empty': 'Wallet is empty, add...',
                'add_claims': 'Add claims',
                'claims_can_add': 'Claims you can add...',
                'no_claims': 'You don\'t have any claim available',
                'noclaimavailable1': 'You need a claim of ',
                'noclaimavailable2': ' type',
                'request_claim': 'Claim request',
                'your_claims': 'Your claims',
                'permissions': 'Permisions',
                'send': 'Request',
                'manage': 'Manage data',
                'add': 'Add',
                'show_claims': 'Show claims',
                'add_title': 'Add address',
                'detail': 'Detail',
                'signature': 'Signature',
                'date': 'Date',
                'valid_from': 'Valid from',
                'valid_until': 'Valid until',
                'from': 'From',
                'to': 'To',
                'blockchain_record': 'Blockchain record',
                'transaction': 'Transaction',
                'back_to_list': 'Go back to list',
                'delete_claim': 'Delete claim',
                'export_claim': 'Export claim',
                'verify_claim': 'Verify claim',
                'provider_code': 'Provider code',
                'select_value': ' -- Select a claim -- ',
                'select': 'Select',
                'cancel': 'Cancel',
                'accept': 'Aceptar',
                'delete_field': 'Delete field',
                'edit_field': 'Edit field',
                'confirm_delete': 'Are you sure you want to delete the claim?',
                'confirm_revokePermission': 'Are you sure you want to revoke the permission?',
                'loading': 'Loading',
                'processing': 'Processing the request',
                'dont_close': 'Don\'t close or reload this window.',
                'granted_to': 'Granted to',
                'revoked_by': 'Revoked by',
                'revocation_date': 'Revocation date',
                'revocation_transaction': 'Revocation transaction',
                'me': 'Me',
                'data': 'Data',
                'back_to_permission': 'Back to permission',
                'activate_camera': 'Activate Camera',
                'take_picture': 'Take picture',
                'clear_picture': 'Clear picture',
                'verify': 'Verify'
            },
            'security': {
                'title': 'Settings',
                'check_password': 'Check password',
                'profile': 'Profile',
                'synchronize': 'Backup/synchronize',
                'synchronizing': 'Synchronizing',
                'explain_message_remote': 'We save your wallet ciphered so only you can access the content. Export your keys to install it in another device.',
                'confirm_message_remote': 'Are you sure you want to store your wallet remotely?',
                'confirm_message_local': 'Are you sure you want to store your wallet locally?',
                'export_wallet': 'Export wallet',
                'export': 'Export'
            }
        },
        'general': {
            'title': 'Agnia Wallet',
            'all_data': 'All data',
            'add_data': 'Add data',
            'select_type': 'Select the data type',
            'label': 'Label',
            'save': 'Save',
            'introduce_code': 'Introduce the code',
            'delete': 'Delete'
        },
        'content': {
            'select_data': 'Select data',
            'grant_permissions': 'Grant permissions',
            'grant_permissions_text_1': 'You are granting persmission to the organization ',
            'grant_permissions_text_2': ' to:',
            'accept': 'Accept',
            'reject': 'Reject',
            'data_related': 'Data related to the use',
            'signing_permission': 'Signing permissions',
            'registering_permission': 'Registering permissions in blockchain',
            'sending_data': 'Sending data and permissions',
            'more_details': 'More details'
        },
        'errors': {
            'error': 'Error',
            'server_error': 'Server error',
            'error_calling': 'Error calling to the provider',
            'response_signature_mismatch': 'Response signature mismatch',
            'wallet_name_required': 'Wallet name is required',
            'password_required': 'Password is required',
            'password2_required': 'Repeat password is required',
            'password_password2_mismatch': 'Password and Repeat password are different',
            'field_required': 'Field required',
            'bad_format': 'Bad format',
            'no_data': 'There is no data of that type in the wallet',
            'wallet_locked': 'Wallet locked',
            'value_not_in_wallet': 'Data not in wallet',
            'retrieving_wallet': 'Error retrieving wallet',
            'wrong_password': 'Wrong password',
            'invalid_data': 'Invalid data',
            'synchronizing_error': 'Synchronizing error'
        },
        'data-types': {
            'email': 'E-mail',
            'phonenumber': 'Phone number',
            'id': 'Identity',
            'name': 'Name',
            'surname': 'Surname',
            'nif': 'NIF'
        },
        'permissions': {
            'PROPER_USE':
            {
                'label': 'Proper use',
                'description': 'Applications related with the main activity of the organization',
                'details': 'Details of proper use permission'
            },
            'COMMERCIAL_USE':
            {
                'label': 'Commercial use',
                'description': 'Other commercial applications that the organization may carry out',
                'details': 'Details of commercial use permission'
            },
        }
    },
    'es': {
        'popup': {
            'title': 'Cartera Agnia',
            'menu': {
                'claims': 'Datos',
                'permissions': 'Permisos',
                'security': 'Configuración',
                'logout': 'Salir'
            },
            'noninitiated':
            {
                'title': 'Fija la contraseña de tu cartera',
                'intro': 'Vamos a crear tu cartera que estará cifrado con tu contraseña',
                'wallet_name': 'Nombre',
                'password': 'Contraseña',
                'password2': 'Repite la contraseña',
                'show_import': 'Ya tengo una cartera',
                'import_file': 'Cartera',
                'file_password': 'Contraseña de la cartera',
                'set': 'Fijar'
            },
            'askpassword':
            {
                'title': 'Desbloquea tu cartera',
                'password': 'Contraseña',
                'unlock': 'Desbloquear'
            },
            'initiated':
            {
                'wallet_empty': 'Wallet está vacío, añade...',
                'add_claims': 'Añade datos',
                'claims_can_add': 'Claims que puedes añadir...',
                'no_claims': 'No tienes ningún claim disponible',
                'noclaimavailable1': 'Necesitas un claim de tipo ',
                'noclaimavailable2': '',
                'request_claim': 'Solicitar claim',
                'your_claims': 'Tus datos',
                'permissions': 'Permisos',
                'send': 'Solicitar',
                'manage': 'Gestionar datos',
                'add': 'Añadir',
                'show_claims': 'Ver datos',
                'add_title': 'Añadir dirección',
                'detail': 'Detalle',
                'signature': 'Firma',
                'date': 'Fecha',
                'valid_from': 'Valido desde',
                'valid_until': 'Valido hasta',
                'from': 'Por',
                'to': 'Para',
                'blockchain_record': 'Registro en blockchain',
                'transaction': 'Transacción',
                'back_to_list': 'Volver al listado',
                'delete_claim': 'Borrar dato',
                'export_claim': 'Exportar dato',
                'verify_claim': 'Verificar dato',
                'provider_code': 'Código de proveedor',
                'select_value': ' -- Seleciona un dato -- ',
                'select': 'Seleccionar',
                'cancel': 'Cancelar',
                'accept': 'Aceptar',
                'delete_field': 'Borrar campo',
                'edit_field': 'Editar campo',
                'confirm_delete': '¿Seguro que desea eliminar el dato?',
                'confirm_revokePermission': '¿Seguro que desea revocar el permiso?',
                'loading': 'Cargando',
                'processing': 'Procesando la solicitud',
                'dont_close': 'No cierres o refresques esta ventana.',
                'granted_to': 'Concedido a',
                'revoked_by': 'Revocado por',
                'revocation_date': 'Fecha de revocación',
                'revocation_transaction': 'Transacción de revocación',
                'me': 'Mí',
                'data': 'Datos',
                'back_to_permission': 'Volver al permiso',
                'activate_camera': 'Activar Cámara',
                'take_picture': 'Tomar fotografía',
                'clear_picture': 'Borrar fotografía',
                'verify': 'Verificar'
            },
            'security': {
                'title': 'Configuración',
                'check_password': 'Verificación de contraseña',
                'profile': 'Perfil',
                'synchronize': 'Backup/sincronizar',
                'synchronizing': 'Sincronizando',
                'explain_message_remote': 'Tu wallet se guarda codificado por lo que solo tú puedes ver el contenido. Si quieres instalarlo en otro dispositivo exporta las claves.',
                'confirm_message_remote': '¿Estás seguro de que quieres almacenar tu wallet remotamente?',
                'confirm_message_local': '¿Estás seguro de que quieres almacenar tu wallet localmente?',
                'export_wallet': 'Exportar wallet',
                'export': 'Exportar'
            }
        },
        'general': {
            'title': 'Cartera Agnia',
            'all_data': 'Todos los datos',
            'add_data': 'Añadir dato',
            'select_type': 'Selecciona el tipo de dato',
            'label': 'Etiqueta',
            'save': 'Guardar',
            'introduce_code': 'Introduce el código',
            'delete': 'Eliminar'
        },
        'content': {
            'select_data': 'Selecciona un dato',
            'grant_permissions': 'Conceder permisos',
            'grant_permissions_text_1': 'Vas a conceder permisos a la organización ',
            'grant_permissions_text_2': ' para:',
            'accept': 'Aceptar',
            'reject': 'Rechazar',
            'data_related': 'Datos asociados al uso',
            'signing_permission': 'Firmando los permisos',
            'registering_permission': 'Registrando en el blockchain los permisos',
            'sending_data': 'Enviando los datos y los permisos',
            'more_details': 'Más detalles'
        },
        'errors': {
            'error': 'Se ha producido un error',
            'server_error': 'Se ha producido un error en el servidor',
            'error_calling': 'Se ha producido un error llamando al proveedor',
            'response_signature_mismatch': 'La firma de la respuesta no es correcta',
            'wallet_name_required': 'El nombre del wallet es obligatorio',
            'password_required': 'La contraseña es obligatoria',
            'password2_required': 'Tienes que repetir la contraseña',
            'password_password2_mismatch': 'La contraseña y la repetición no coinciden',
            'field_required': 'Campo obligatorio',
            'bad_format': 'Formato incorrecto',
            'no_data': 'No hay ningún dato de ese tipo en la cartera',
            'wallet_locked': 'Cartera bloqueada',
            'value_not_in_wallet': 'El dato no está en el wallet',
            'retrieving_wallet': 'Error recuperando el wallet',
            'wrong_password': 'Contraseña incorrecta',
            'invalid_data': 'Datos no válidos',
            'synchronizing_error': 'Error de sincronización'
        },
        'data-types': {
            'email': 'Correo electrónico',
            'phonenumber': 'Número de teléfono',
            'id': 'Identidad',
            'name': 'Nombre',
            'surname': 'Apellidos',
            'nif': 'NIF'
        },
        'permissions': {
            'PROPER_USE':
            {
                'label': 'Usos propios',
                'description': 'Usos relacionados con la actividad realizada por la organización',
                'details': 'Detalles del permiso de usos propios que puede ser un texto largo.<br>\
                Con varias líneas que hay que ver como presentamos<br>\
                para que se vea correctamente con todo el lingo<br>\
                legal que no entiende nadie, ni siquiera los que lo escriben,<br>\
                lo que hace que la gente no sepa lo que está haciendo.'
            },
            'COMMERCIAL_USE':
            {
                'label': 'Usos comerciales',
                'description': 'Otros usos comerciales que puedan ser llevados a cabo por la organización',
                'details': 'Detalles del permiso de uso comercial'
            },
        }
    },

};